<?php
use Illuminate\Database\Capsule\Manager as Capsule;
function laoxuehost_config() {
	$configarray = array(
		'name' => '老薛主机',
		'description' => '对接老薛主机实现自动开通产品',
		'version' => '1.0',
		'premium' => true,
		'author' => '<a href="http://www.laoxuehost.com" target="_blank">老薛主机</a>',
		'language' => 'english',
		'fields' => array(
			'apiurl' => array ('FriendlyName' => 'API URL', 'Type' => 'text', 'Size' => '25', 'Default' => 'https://my.laoxuehost.net/api/', 'Description' => '老薛主机API地址，包含http://或https://' ),
			'email' => array ('FriendlyName' => 'Email', 'Type' => 'text', 'Size' => '25', 'Description' => '邮箱地址，例如：sales@laoxuehost.com' ),
			'accesskey' => array ('FriendlyName' => 'Access Key', 'Type' => 'text', 'Size' => '25', 'Description' => 'API密钥，在老薛主机获取' ),
			'promocode' => array ('FriendlyName' => 'Promo Code', 'Type' => 'text', 'Size' => '25', 'Description' => '选填，老薛主机提供的促销码' ),
		),
	);
	return $configarray;
}
//创建laoxuehost_servicelist表
function laoxuehost_activate() {
	if ( ! Capsule::schema()->hasTable('laoxuehost_servicelist') ) {
		Capsule::schema()->create('laoxuehost_servicelist', function ($table) {
			$table->increments('id');
			$table->integer('locserviceid')->unique();
			$table->integer('serviceid');
			$table->integer('invoiceid');
		});
	}
}

//输出
function laoxuehost_output($vars) {
	if( isset($_POST['action']) && 'add_service' == $_POST['action'] ) {
		$locservice = trim( $_POST['locservice'] );
		$laoxueservice = trim( $_POST['laoxueservice'] );
		$laoxueinvoice = trim( $_POST['laoxueinvoice'] );
		if( empty($locservice) || empty($laoxueservice) ) {
			echo '<div class="errorbox">本地服务ID和老薛服务ID都不能为空！</div>';
		} else {
			$count = Capsule::table('laoxuehost_servicelist')->where('locserviceid', $locservice)->count();
			if($count > 0) {
				Capsule::table('laoxuehost_servicelist')->where('locserviceid', $locservice)->update(
					[
						'serviceid' => $laoxueservice,
						'invoiceid' => $laoxueinvoice,
					]
				);
			} else {
				Capsule::table('laoxuehost_servicelist')->insert(
					[
						'locserviceid' => $locservice,
						'serviceid' => $laoxueservice,
						'invoiceid' => $laoxueinvoice,
					]
				);
			}
			echo '<div class="successbox">添加成功！</div>';
		}
	}
	
	if( empty($vars['email']) || empty($vars['accesskey']) || empty($vars['apiurl']) ) {
		echo '<div class="errorbox">您还没有设置好API接口</div>';
	} else {
		$this_time = time();
		$data = array();
		$data['info']['usemoney'] = 0;
		$signature = sha1($vars['email'] . $this_time . $vars['accesskey']);
		$fields = array(
			'userid' => $vars['email'],
			'timestamp' => $this_time,
			'strcmd' => "other" . "\r\n" . "get" . "\r\n" . "entityname:usemoney",
			'versig' => $signature,
		);
		if (function_exists('curl_exec')) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
			curl_setopt($ch, CURLOPT_URL, $vars['apiurl']);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
			curl_setopt($ch, CURLOPT_TIMEOUT, 10);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$data = curl_exec($ch);
			curl_close($ch);
			$data = json_decode($data, true);
		}
		
		if($data['code'] == 200) {
			echo '<div class="successbox">您在老薛主机的余额还有：¥ ' . $data['info']['usemoney'] . ' 元<br />API对接已成功，赶紧去设置产品吧！</div>';
		} else {
			echo '<div class="errorbox">获取账户余额失败！<br />如果确定API设置正确，请联系老薛主机。</div>';
		}
		
		echo '<p>手动添加业务编号，使本地（WHMCS）的服务ID（非订单号）与老薛的服务ID对应。一般不需要此操作，模块执行开通主机时会自动添加，仅用于手动为用户添加产品。</p>
			<form action="#" method="post">
				<p><input type="text" name="locservice" placeholder="输入本地服务ID" size="30" value="" class="form-control input-250 input-inline" /></p>
				<p><input type="text" name="laoxueservice" placeholder="输入老薛服务ID" size="30" value="" class="form-control input-250 input-inline" /></p>
				<p><input type="text" name="laoxueinvoice" placeholder="输入老薛账单ID" size="30" value="" class="form-control input-250 input-inline" /></p>
				<p><input type="submit" value="添加" class="btn btn-primary" /><input type="hidden" name="action" value="add_service" /></p>
			</form>';
	}
}
?>