<?php
use Illuminate\Database\Capsule\Manager as Capsule;
/* Post数据 */
function laoxuehost_post($cmdstrng) {
	$addons = Capsule::table('tbladdonmodules')->where('module', 'laoxuehost')->get();
	$addon_setting = array();
	foreach($addons as $addon) {
		if($addon->setting == 'email') {
			$addon_setting['email'] = $addon->value;
		} elseif($addon->setting == 'apiurl') {
			$addon_setting['apiurl'] = $addon->value;
		} elseif($addon->setting == 'accesskey') {
			$addon_setting['accesskey'] = $addon->value;
		} elseif($addon->setting == 'promocode') {
			$addon_setting['promocode'] = $addon->value;
		}
	}
	
	if( empty($addon_setting['email']) || empty($addon_setting['apiurl']) || empty($addon_setting['accesskey']) ) {
		return array('code'=>'API信息不正确？');
	}
	
	$this_time = time();
	$signature = sha1($addon_setting['email'] . $this_time . $addon_setting['accesskey']);
	$fields = array(
		'userid' => $addon_setting['email'],
		'timestamp' => $this_time,
		'strcmd' => $cmdstrng,
		'versig' => $signature,
	);
	if (function_exists('curl_exec')) {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_URL, $addon_setting['apiurl']);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
		curl_setopt($ch, CURLOPT_TIMEOUT, 10);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$data = curl_exec($ch);
		curl_close($ch);
		return json_decode($data, true);
	}
}
//获取管理员账号
function laoxuehost_getadmin() {
	$adminuser = Capsule::table('tbladmins')->where('roleid', 1)->first();
	return $adminuser->username;
}
//获取产品详情
function laoxuehost_get_client_product($clientid, $serviceid) {
	$values = array(
		'clientid' => $clientid,
		'serviceid' => $serviceid,
	);
	$adminuser = laoxuehost_getadmin();
	$products = localAPI('getclientsproducts', $values, $adminuser);
	$product = $products['products']['product'][0];
	return $product;
}
//获取上级服务商Service ID
function laoxuehost_get_serviceid($serviceid) {
	$servicelist = Capsule::table('laoxuehost_servicelist')->where('locserviceid', $serviceid)->first();
	return $servicelist->serviceid;
}
//获取主机信息
function laoxuehost_get_hostinfo($serviceid) {
	$cmdstrng = "vhost" . "\r\n" . "get" . "\r\n" . "entityname:vhost" . 
		"\r\n" . "serviceid:" . $serviceid;
	
	return laoxuehost_post($cmdstrng);
}
//创建主机
function laoxuehost_createhost($serviceid) {
	$cmdstrng = "vhost" . "\r\n" . "create" . "\r\n" . "entityname:vhost" . 
		"\r\n" . "serviceid:" . $serviceid;
	
	return laoxuehost_post($cmdstrng);
}
?>