<?php
use Illuminate\Database\Capsule\Manager as Capsule;
require_once('func.php');

function laoxuehost_ConfigOptions() {
    $configarray = array(
		'productname' => array (
			'FriendlyName' => 'Product Name',
			'Type' => 'text',
			'Size' => '25',
			'Description' => ' ',
			'Default' => ' ',
		),
	);
	return $configarray;
}
//开通主机
function laoxuehost_CreateAccount($params) {
	$parent_serviceid = laoxuehost_get_serviceid($params['serviceid']);
	$producttype = $params['configoption1'];
	if( empty($parent_serviceid) && strstr(strtolower($producttype), 'vps') === false ) {
		//下订单
		$promocode = Capsule::table('tbladdonmodules')->where('module', 'laoxuehost')->where('setting', 'promocode')->first();
		$promocode = $promocode->value;
		$product = laoxuehost_get_client_product($params['clientsdetails']['userid'], $params['serviceid']);
		$add_cmdstrng = "vhost" . "\r\n" . "add" . "\r\n" . "entityname:vhost" . 
			"\r\n" . "producttype:" . $producttype . 
			"\r\n" . "billingcycle:" . $product['billingcycle'] . 
			"\r\n" . "domain:" . $params['domain'] . 
			"\r\n" . "promocode:" . $promocode;
		$add_result = laoxuehost_post($add_cmdstrng);
		$result = $add_result['code'];
		
		if($add_result['code'] == 200) {
			//获取主机信息
			$hostinfo = laoxuehost_get_hostinfo($add_result['info']['serviceid']);
			if($hostinfo['code'] == 200) {			
				$pass_command = 'encryptpassword';
				$pass_data = array(
					'password2' => $hostinfo['info']['password'],
				);
				$adminuser = laoxuehost_getadmin();
				$pass_res = localAPI($pass_command, $pass_data, $adminuser);
				Capsule::table('tblhosting')
					->where('id', $params['serviceid'])
					->update(
						[
							'username' => $hostinfo['info']['username'],
							'password' => $pass_res['password'],
							'dedicatedip' => $hostinfo['info']['dedicatedip'],
						]
					);
				Capsule::table('laoxuehost_servicelist')->insert([
					'locserviceid' => $params['serviceid'],
					'serviceid' => $add_result['info']['serviceid'],
					'invoiceid' => $add_result['info']['invoiceid'],
				]);
				
			}
			
			$result = $hostinfo['code'];
		}
		
	} else {
		$create_result = laoxuehost_createhost($parent_serviceid);
		$result = $create_result['code'];
	}
	
	return $result == 200 ? 'success' : $result;
}
//主机续费
function laoxuehost_Renew($params) {
	$parent_serviceid = laoxuehost_get_serviceid($params['serviceid']);
	if(empty($parent_serviceid)) {
		return '获取服务ID失败';
	}
	$cmdstrng = "vhost" . "\r\n" . "renew" . "\r\n" . "entityname:vhost" . 
		"\r\n" . "serviceid:" . $parent_serviceid;
	$result = laoxuehost_post($cmdstrng);
	return $result['code'] == 200 ? 'success' : $result['code'];
}

//用户手动续费
function laoxuehost_userrenew( $params ) {
	$adminuser = laoxuehost_getadmin();
	//生成新账单，能够自动扣款
	$geninvoices_command = 'geninvoices';
	$geninvoices_data = array(
		'clientid' => $params['clientsdetails']['userid'],
		'serviceids' => array($params['serviceid']),
	);
	$geninvoices_res = localAPI($geninvoices_command, $geninvoices_data, $adminuser);
	
	if($geninvoices_res['result'] == 'success') {
		$invoiceid = $geninvoices_res['latestinvoiceid'];
		$currentdate = date('Y-m-d');
		$updateinvoice_data = array(
			'invoiceid' => $invoiceid,
			'date' => $currentdate,
			'duedate' => $currentdate,
		);
		localAPI( 'updateinvoice', $updateinvoice_data, $adminuser );
		
		$viewinvoice_url = 'viewinvoice.php?id=' . $invoiceid;
		header("location: $viewinvoice_url");
	} else {
		$invoice_url = 'clientarea.php?action=invoices';
		header("location: $invoice_url");
	}

}
function laoxuehost_ClientAreaCustomButtonArray() {
	return array( '续费主机' => 'userrenew' );
}

//修改套餐
function laoxuehost_ChangePackage($params) {
	$parent_serviceid = laoxuehost_get_serviceid($params['serviceid']);
	if(empty($parent_serviceid)) {
		return '获取服务ID失败';
	}
	$producttype = $params['configoption1'];
	$product = laoxuehost_get_client_product($params['clientsdetails']['userid'], $params['serviceid']);
	$cmdstrng = "vhost" . "\r\n" . "mod" . "\r\n" . "entityname:package" . 
		"\r\n" . "serviceid:" . $parent_serviceid . 
		"\r\n" . "producttype:" . $producttype .  
		"\r\n" . "billingcycle:" . $product['billingcycle'];
	
	$result = laoxuehost_post($cmdstrng);
	return $result['code'] == 200 ? 'success' : $result['code'];
}

//修改FTP密码
function laoxuehost_ChangePassword($params) {
	$parent_serviceid = laoxuehost_get_serviceid($params['serviceid']);
	if(empty($parent_serviceid)) {
		return '获取服务ID失败';
	}
	$cmdstrng = "vhost" . "\r\n" . "mod" . "\r\n" . "entityname:ftppassword" . 
		"\r\n" . "serviceid:" . $parent_serviceid . 
		"\r\n" . "ftppassword:" . $params['password'];
	
	$result = laoxuehost_post($cmdstrng);
	return $result['code'] == 200 ? 'success' : $result['code'];
}

//管理员产品管理页跳转到控制面板
function laoxuehost_LoginLink($params) {
	$parent_serviceid = laoxuehost_get_serviceid($params['serviceid']);
	if(empty($parent_serviceid)) {
		return '获取服务ID失败';
	}
	$hostinfo = laoxuehost_get_hostinfo($parent_serviceid);
	if($hostinfo['code'] == 200 && $hostinfo['info']['status'] == 'Active') {
		if($hostinfo['info']['module'] == 'cpanel') {
			echo '<a href="https://' . $hostinfo['info']['serverip'] . ':2083/login/?user=' . $hostinfo['info']['username'] . '&pass=' . $hostinfo['info']['password'] . '" target="_blank">登录控制面板</a>';
		} elseif($hostinfo['info']['module'] == 'xensystem') {
			echo '';
		}
	}
}
//用户跳转控制面板
function laoxuehost_ClientArea($params) {
	$parent_serviceid = laoxuehost_get_serviceid($params['serviceid']);
	if(empty($parent_serviceid)) {
		return '获取服务ID失败';
	}
	$hostinfo = laoxuehost_get_hostinfo($parent_serviceid);
	if($hostinfo['code'] == 200 && $hostinfo['info']['status'] == 'Active') {
		if($hostinfo['info']['module'] == 'cpanel') {
			$result = '<form action="https://' . $hostinfo['info']['serverip'] . ':2083/login/" method="post" target="_blank">
				<input type="hidden" name="user" value="' . $hostinfo['info']['username'] . '" />
				<input type="hidden" name="pass" value="' . $hostinfo['info']['password'] . '" />
				<input type="submit" class="btn btn-primary" value="登录控制面板" />
				</form>';
		} elseif($hostinfo['info']['module'] == 'xensystem') {
			$result = '';
		}
	}
	return $result;
}
//删除产品
function laoxuehost_TerminateAccount($params) {
	$parent_serviceid = laoxuehost_get_serviceid($params['serviceid']);
	if(empty($parent_serviceid)) {
		return '获取服务ID失败';
	}
	$cmdstrng = "vhost" . "\r\n" . "del" . "\r\n" . "entityname:vhost" . 
		"\r\n" . "serviceid:" . $parent_serviceid;
	
	$result = laoxuehost_post($cmdstrng);
	return $result['code'] == 200 ? 'success' : $result['code'];
}
//暂停产品
function laoxuehost_SuspendAccount($params) {
	$parent_serviceid = laoxuehost_get_serviceid($params['serviceid']);
	if(empty($parent_serviceid)) {
		return '获取服务ID失败';
	}
	$cmdstrng = "vhost" . "\r\n" . "suspend" . "\r\n" . "entityname:vhost" . 
		"\r\n" . "serviceid:" . $parent_serviceid;
	
	$result = laoxuehost_post($cmdstrng);
	return $result['code'] == 200 ? 'success' : $result['code'];
}
//取消暂停
function laoxuehost_UnsuspendAccount($params) {
	$parent_serviceid = laoxuehost_get_serviceid($params['serviceid']);
	if(empty($parent_serviceid)) {
		return '获取服务ID失败';
	}
	$cmdstrng = "vhost" . "\r\n" . "unsuspend" . "\r\n" . "entityname:vhost" . 
		"\r\n" . "serviceid:" . $parent_serviceid;
	
	$result = laoxuehost_post($cmdstrng);
	return $result['code'] == 200 ? 'success' : $result['code'];
}
?>